//* Регулярные выражения

/**
 *
 * . - любой одиночный символ
 * [a-n], [0-9] - любой из символов, диапазон
 * $ - конец строки
 * ^ - начало строки
 * \ - экранирование
 * \d - любая цифра
 * \D - все, кроме цифр
 * \s - пробелы
 * \S - все, кроме пробелов
 * \w - буква
 * \W - все, кроме букв
 * \b - граница слова
 * \B - все, кроме границ слова
 *
 */

//* Квантификация

/**
 *
 * n{4} - искать символ 'n' 4 раза
 * n{4,6} - искать символ 'n' от 4 до 6
 * + - от 1 и выше
 * \* - от 0 и выше
 * \? - ноль или один раз
 *
 */

//? Шаблон проверяющий номер телефона

/**
 *
 * +38 (050)
 * ^\+38\s\(\d{3}\)
 * (начинаеться с +38, \s пробел, (\d{3}\) только цифры в колличестве 3х)
 *
 */

//? Шаблон проверяющий email

/**
 *
 * \w+@\w\.\w+
 * ('\w' любая буква, '+' от одной и выше, @ содержит символ,'\w' любая буква, \. содержит точку)
 *
 * hello@gmail.com.ua
 * hello@ya.ru
 * @gmail.com
 *
 * if (target.value.match(/\w+@\w+\.\w+/))
 * if (target.value.match(/[a-z0-9]@\w+\.\w+/))
 *
 */

//? Шаблон проверяющий номер кредитной карты?

/**
 * 
 * 4444 4545 1365 1382
 * \d{4}\s\d{4}\s\d{4}\s\d{4}
 * 
 * (\s|-) либо пробелб либо '-'
 * 
 * 4444-4545-1365-1382
 * \d{4}(\s|-)\d{4}
 * 
 * 
 */